diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/wscript ns-3.34/wscript
--- ns-3.33/wscript	2021-01-09 10:19:23.000000000 -0800
+++ ns-3.34/wscript	2021-07-14 10:31:07.000000000 -0700
@@ -64,7 +64,8 @@
 Configure.autoconfig = 0
 
 # the following two variables are used by the target "waf dist"
-VERSION = open("VERSION", "rt").read().strip()
+with open("VERSION", "rt") as f:
+    VERSION = f.read().strip()
 APPNAME = 'ns'
 
 wutils.VERSION = VERSION
@@ -118,7 +119,7 @@
           print(name.ljust(25), end=' ')
 
 # return types of some APIs differ in Python 2/3 (type string vs class bytes)
-# This method will decode('utf-8') a byte object in Python 3, 
+# This method will decode('utf-8') a byte object in Python 3,
 # and do nothing in Python 2
 def maybe_decode(input):
     if sys.version_info < (3,):
@@ -137,12 +138,13 @@
     opt.load('compiler_cxx')
     opt.load('cflags')
     opt.load('gnu_dirs')
+    opt.load('boost', tooldir=['waf-tools'])
 
     opt.add_option('--check-config',
                    help=('Print the current configuration.'),
                    action="store_true", default=False,
                    dest="check_config")
-    
+
     opt.add_option('--cwd',
                    help=('Set the working directory for a program.'),
                    action="store", type="string", default=None,
@@ -258,7 +260,7 @@
                    dest='enable_desmetrics')
     opt.add_option('--cxx-standard',
                    help=('Compile NS-3 with the given C++ standard'),
-                   type='string', default='-std=c++11', dest='cxx_standard')
+                   type='string', dest='cxx_standard')
     opt.add_option('--enable-asserts',
                    help=('Enable the asserts regardless of the compile mode'),
                    action="store_true", default=False,
@@ -345,15 +347,15 @@
         profile = get_build_profile(env)
     else:
         profile = get_build_profile()
-        
+
     print("---- Summary of optional NS-3 features:")
     print("%-30s: %s%s%s" % ("Build profile", Logs.colors('GREEN'),
                              profile, Logs.colors('NORMAL')))
     bld = wutils.bld
     print("%-30s: %s%s%s" % ("Build directory", Logs.colors('GREEN'),
                              Options.options.out, Logs.colors('NORMAL')))
-    
-    
+
+
     for (name, caption, was_enabled, reason_not_enabled) in sorted(env['NS3_OPTIONAL_FEATURES'], key=lambda s : s[1]):
         if was_enabled:
             status = 'enabled'
@@ -363,7 +365,210 @@
             color = 'RED'
         print("%-30s: %s%s%s" % (caption, Logs.colors(color), status, Logs.colors('NORMAL')))
 
+#  Checking for boost headers and libraries
+#
+#  There are four cases:
+#    A.  Only need headers, and they are required
+#    B.  Also need compiled libraries, and they are required
+#    C.  Only use headers, but they are not required
+#    D.  Use compiled libraries, but they are not required
+#
+#  A.  If you only need includes there are just two steps:
+#
+#    A1.  Add this in your module wscript configure function:
+#
+#        if not conf.require_boost_incs('my-module', 'my module caption'):
+#            return
+#
+#    A2.  Do step FINAL below.
+#
+#  B.  If you also need some compiled boost libraries there are 
+#      three steps (instead of the above):
+#
+#    B1.  Declare the libraries you need by adding to your module wscript:
+#
+#        REQUIRED_BOOST_LIBS = ['lib1', 'lib2'...]
+#
+#        def required_boost_libs(conf):
+#            conf.env['REQUIRED_BOOST_LIBS'] += REQUIRED_BOOST_LIBS
+#
+#    B2.  Check that the libs are present in your module wscript configure function:
+#      
+#        if conf.missing_boost_libs('my-module', 'my module caption', REQUIRED_BOOST_LIBS):
+#            return
+#
+#    B3.  Do step FINAL below.
+#
+#  Finally,
+#
+#    FINAL.  Add boost to your module wscript build function:
+#
+#        # Assuming you have
+#        #  module = bld.create_ns3_module('my-module')
+#        module.use.append('BOOST')
+#
+#  If your use of boost is optional it's even simpler.
+#
+#  C.  For optional headers only, the two steps above are modified a little:
+#
+#    C1.  Add this to your module wscript configure function:
+#
+#        conf.require_boost_incs('my-module', 'my module caption', required=False)
+#        # Continue with config, adjusting for missing boost
+#
+#    C2.  Modify step FINAL as follows
+#
+#        if bld.env['INCLUDES_BOOST']:
+#            module.use.append('BOOST')
+#
+#  D.  For compiled boost libraries
+#
+#    D1.  Do B1 above to declare the libraries you would like to use
+#
+#    D2.  If you need to take action at configure time, 
+#         add to your module wscript configure function:
+#
+#        missing_boost_libs = conf.missing_boost_libs('my-module', 'my module caption', REQUIRED_BOOST_LIBS, required=False)
+#        # Continue with config, adjusting for missing boost libs
+#
+#         At this point you can inspect missing_boost_libs to see 
+#         what libs were found and do the right thing.  
+#         See below for preprocessor symbols which will be available 
+#         in your source files.
+#
+#    D3.  If any of your libraries are present add to your 
+#         module wscript build function:
+#
+#        missing_boost_libs = bld.missing_boost_libs('lib-opt', REQUIRED_BOOST_LIBS)
+#        # Continue with build, adjusting for missing boost libs
+#  
+#         At this point you can inspect missing_boost_libs to see 
+#         what libs were found and do the right thing.  
+#
+#  In all cases you can test for boost in your code with
+#
+#      #ifdef HAVE_BOOST
+#
+#  Each boost compiled library will be indicated with a 'HAVE_BOOST_<lib>' 
+#  preprocessor symbol, which you can test.  For example, for the boost 
+#  Signals2 library:
+#
+#      #ifdef HAVE_BOOST_SIGNALS2
+#
+
+def require_boost_incs(conf, module, caption, required=True):
+
+    conf.to_log('boost: %s wants incs, required: %s' % (module, required))
+    if conf.env['INCLUDES_BOOST']:
+        conf.to_log('boost: %s: have boost' % module)
+        return True
+    elif not required:
+        conf.to_log('boost: %s: no boost, but not required' % module)
+        return False
+    else:
+        conf.to_log('boost: %s: no boost, but required' % module)
+        conf.report_optional_feature(module, caption, False,
+                                     "boost headers required but not found")
+
+        # Add this module to the list of modules that won't be built
+        # if they are enabled.
+        conf.env['MODULES_NOT_BUILT'].append(module)
+        return False
+
+#  Report any required boost libs which are missing
+#  Return values of truthy are bad; falsey is good:
+#    If all are present return False (non missing)
+#    If boost not present, or no libs return True
+#    If some libs present, return the list of missing libs
+def conf_missing_boost_libs(conf, module, caption, libs, required= True):
+    conf.to_log('boost: %s wants %s, required: %s' % (module, libs, required))
+
+    if not conf.require_boost_incs(module, caption, required):
+        # No headers found, so the libs aren't there either
+        return libs
+
+    missing_boost_libs = [lib for lib in libs if lib not in conf.boost_libs]
+
+    if required and missing_boost_libs:
+        if not conf.env['LIB_BOOST']:
+            conf.to_log('boost: %s requires libs, but none found' % module)
+            conf.report_optional_feature(module, caption, False,
+                                         "No boost libraries were found")
+        else:
+            conf.to_log('boost: %s requires libs, but missing %s' % (module, missing_boost_libs))
+            conf.report_optional_feature(module, caption, False,
+                                         "Required boost libraries not found, missing: %s" % missing_boost_libs)
+
+        # Add this module to the list of modules that won't be built
+        # if they are enabled.
+        conf.env['MODULES_NOT_BUILT'].append(module)
+        return missing_boost_libs
+
+    # Required libraries were found, or are not required
+    return missing_boost_libs
+
+def get_boost_libs(libs):
+    names = set()
+    for lib in libs:
+        if lib.startswith("boost_"):
+            lib = lib[6:]
+        if lib.endswith("-mt"):
+            lib = lib[:-3]
+        names.add(lib)
+    return names
+
+def configure_boost(conf):
+    conf.to_log('boost: loading conf')
+    conf.load('boost')
+
+    # Find Boost libraries by modules
+    conf.to_log('boost: scanning for required libs')
+    conf.env['REQUIRED_BOOST_LIBS'] = []
+    for modules_dir in ['src', 'contrib']:
+        conf.recurse (modules_dir, name="get_required_boost_libs", mandatory=False)
+    # Check for any required boost libraries
+    if conf.env['REQUIRED_BOOST_LIBS'] is not []:
+        conf.env['REQUIRED_BOOST_LIBS'] = list(set(conf.env['REQUIRED_BOOST_LIBS']))
+        conf.to_log("boost: libs required: %s" % conf.env['REQUIRED_BOOST_LIBS'])
+        conf.check_boost(lib=' '.join (conf.env['REQUIRED_BOOST_LIBS']), mandatory=False, required=False)
+        if not conf.env['LIB_BOOST']:
+            conf.env['LIB_BOOST'] = []
+    else:
+        # Check with no libs, so we find the includes
+        conf.check_boost(mandatory=False, required=False)
+
+    conf.to_log('boost: checking if we should define HAVE_BOOST')
+    if conf.env['INCLUDES_BOOST']:
+        conf.to_log('boost: defining HAVE_BOOST')
+        conf.env.append_value ('CPPFLAGS', '-DHAVE_BOOST')
+
+    # Some boost libraries may have been found.  
+    # Add preprocessor symbols for them
+    conf.to_log('boost: checking which libs are present')
+    if conf.env['LIB_BOOST']:
+        conf.boost_libs = get_boost_libs(conf.env['LIB_BOOST'])
+        for lib in conf.boost_libs:
+            msg='boost: lib present: ' + lib
+            if lib in conf.env['REQUIRED_BOOST_LIBS']:
+                have = '-DHAVE_BOOST_' + lib.upper()
+                conf.to_log('%s, requested, adding %s' % (msg, have))
+                conf.env.append_value('CPPFLAGS', have)
+            else:
+                conf.to_log('%s, not required, ignoring' % msg)
+
+    boost_libs_missing = [lib for lib in conf.env['REQUIRED_BOOST_LIBS'] if lib not in conf.boost_libs]
+    for lib in boost_libs_missing:
+        conf.to_log('boost: lib missing: %s' % lib)
+
+def bld_missing_boost_libs (bld, module, libs):
+    missing_boost_libs = [lib for lib in libs if lib not in bld.boost_libs]
+    return missing_boost_libs
+
 def configure(conf):
+    # Waf does not work correctly if the absolute path contains whitespaces
+    if (re.search(r"\s", os.getcwd ())):
+        conf.fatal('Waf does not support whitespace in the path to current working directory: %s' % os.getcwd())
+
     conf.load('relocation', tooldir=['waf-tools'])
 
     # attach some extra methods
@@ -371,6 +576,9 @@
     conf.check_compilation_flag = types.MethodType(_check_compilation_flag, conf)
     conf.report_optional_feature = types.MethodType(report_optional_feature, conf)
     conf.check_optional_feature = types.MethodType(check_optional_feature, conf)
+    conf.require_boost_incs = types.MethodType(require_boost_incs, conf)
+    conf.missing_boost_libs = types.MethodType(conf_missing_boost_libs, conf)
+    conf.boost_libs = set()
     conf.env['NS3_OPTIONAL_FEATURES'] = []
 
     conf.load('compiler_c')
@@ -415,7 +623,7 @@
         env['BUILD_SUFFIX'] = ''
     else:
         env['BUILD_SUFFIX'] = '-'+Options.options.build_profile
-    
+
     env['APPNAME'] = wutils.APPNAME
     env['VERSION'] = wutils.VERSION
 
@@ -425,11 +633,11 @@
                        ('.'.join(conf.env['CC_VERSION']), '.'.join(map(str, gcc_min_version))))
 
     if conf.env['CXX_NAME'] in ['gcc', 'icc']:
-        if Options.options.build_profile == 'release': 
-            env.append_value('CXXFLAGS', '-fomit-frame-pointer') 
-        if Options.options.build_profile == 'optimized': 
+        if Options.options.build_profile == 'release':
+            env.append_value('CXXFLAGS', '-fomit-frame-pointer')
+        if Options.options.build_profile == 'optimized':
             if conf.check_compilation_flag('-march=native'):
-                env.append_value('CXXFLAGS', '-march=native') 
+                env.append_value('CXXFLAGS', '-march=native')
             env.append_value('CXXFLAGS', '-fstrict-overflow')
             if conf.env['CXX_NAME'] in ['gcc']:
                 env.append_value('CXXFLAGS', '-Wstrict-overflow=2')
@@ -457,13 +665,19 @@
         if Utils.unversioned_sys_platform() == 'darwin':
             if tuple(map(int, conf.env['CC_VERSION'])) >= darwin_clang_version_warn_unused_local_typedefs:
                 env.append_value('CXXFLAGS', '-Wno-unused-local-typedefs')
+
             if tuple(map(int, conf.env['CC_VERSION'])) >= darwin_clang_version_warn_potentially_evaluated:
+
                 env.append_value('CXXFLAGS', '-Wno-potentially-evaluated-expression')
+
         else:
             if tuple(map(int, conf.env['CC_VERSION'])) >= clang_version_warn_unused_local_typedefs:
+
                 env.append_value('CXXFLAGS', '-Wno-unused-local-typedefs')
+
             if tuple(map(int, conf.env['CC_VERSION'])) >= clang_version_warn_potentially_evaluated:
                 env.append_value('CXXFLAGS', '-Wno-potentially-evaluated-expression')
+
     env['ENABLE_STATIC_NS3'] = False
     if Options.options.enable_static:
         if Utils.unversioned_sys_platform() == 'darwin':
@@ -481,25 +695,54 @@
                 conf.report_optional_feature("static", "Static build", False,
                                              "Link flag -Wl,--whole-archive,-Bstatic does not work")
 
-    # Enables C++-11 support by default, unless user specified another option
-    # Warn the user if the CXX Standard flag provided was not recognized  
-    if conf.check_compilation_flag(Options.options.cxx_standard):
-        env.append_value('CXXFLAGS', Options.options.cxx_standard)
-    else:
-        Logs.warn("CXX Standard flag " + Options.options.cxx_standard + " was not recognized, using compiler's default")
+    # Checks if environment variable specifies the C++ language standard and/or
+    # if the user has specified the standard via the -cxx-standard argument
+    # to 'waf configure'.  The following precedence and behavior is implemented:
+    # 1) if user does not specify anything, Waf will use the default standard
+    #    configured for ns-3, which is configured below
+    # 2) if user specifies the '-cxx-standard' option, it will be used instead
+    #    of the default.
+    #    Example:  ./waf configure --cxx-standard=-std=c++14
+    # 3) if user specifies the C++ standard via the CXXFLAGS environment
+    #    variable, it will be used instead of the default.
+    #    Example: CXXFLAGS="-std=c++14" ./waf configure
+    # 4) if user specifies both the CXXFLAGS environment variable and the
+    #    -cxx-standard argument, the latter will take precedence and a warning
+    #    will be emitted in the configure output if there were conflicting
+    #    standards between the two.
+    #    Example: CXXFLAGS="-std=c++14" ./waf configure --cxx-standard=-std=c++17
+    #    (in the above scenario, Waf will use c++17 but warn about it)
+    # Note: If the C++ standard is not recognized, configuration will error exit
+    cxx_standard = ""
+    cxx_standard_env = ""
+    for flag in env['CXXFLAGS']:
+        if flag[:5] == "-std=":
+            cxx_standard_env = flag
+
+    if not cxx_standard_env and Options.options.cxx_standard:
+        cxx_standard = Options.options.cxx_standard
+        env.append_value('CXXFLAGS', cxx_standard)
+    elif cxx_standard_env and not Options.options.cxx_standard:
+        cxx_standard = cxx_standard_env
+        # No need to change CXXFLAGS
+    elif cxx_standard_env and Options.options.cxx_standard and cxx_standard_env != Options.options.cxx_standard:
+        Logs.warn("user-specified --cxx-standard (" + 
+            Options.options.cxx_standard + ") does not match the value in CXXFLAGS (" + cxx_standard_env + "); Waf will use the --cxx-standard value")
+        cxx_standard = Options.options.cxx_standard
+        env['CXXFLAGS'].remove(cxx_standard_env)
+        env.append_value('CXXFLAGS', cxx_standard)
+    elif cxx_standard_env and Options.options.cxx_standard and cxx_standard_env == Options.options.cxx_standard:
+        cxx_standard = Options.options.cxx_standard
+        # No need to change CXXFLAGS
+    elif not cxx_standard and not Options.options.cxx_standard:
+        cxx_standard = "-std=c++11"
+        env.append_value('CXXFLAGS', cxx_standard)
 
-    # Find Boost libraries by modules
-    conf.env['REQUIRED_BOOST_LIBS'] = []
-    for modules_dir in ['src', 'contrib']:
-        conf.recurse (modules_dir, name="get_required_boost_libs", mandatory=False)
+    if not conf.check_compilation_flag(cxx_standard):
+        raise Errors.ConfigurationError("Exiting because C++ standard value " + cxx_standard + " is not recognized")
 
-    if conf.env['REQUIRED_BOOST_LIBS'] is not []:
-        conf.load('boost')
-        conf.check_boost(lib=' '.join (conf.env['REQUIRED_BOOST_LIBS']), mandatory=False)
-        if not conf.env['LIB_BOOST']:
-            conf.check_boost(lib=' '.join (conf.env['REQUIRED_BOOST_LIBS']), libpath="/usr/lib64", mandatory=False)
-            if not conf.env['LIB_BOOST']:
-                conf.env['LIB_BOOST'] = []
+    # Handle boost
+    configure_boost(conf)
 
     # Set this so that the lists won't be printed at the end of this
     # configure command.
@@ -514,21 +757,21 @@
 
     # Set the list of enabled modules.
     if Options.options.enable_modules:
-        # Use the modules explicitly enabled. 
+        # Use the modules explicitly enabled.
         _enabled_mods = []
         _enabled_contrib_mods = []
-        for mod in Options.options.enable_modules.split(','): 
-            if mod in conf.env['NS3_MODULES'] and mod.startswith('ns3-'): 
+        for mod in Options.options.enable_modules.split(','):
+            if mod in conf.env['NS3_MODULES'] and mod.startswith('ns3-'):
                 _enabled_mods.append(mod)
-            elif 'ns3-' + mod in conf.env['NS3_MODULES']: 
+            elif 'ns3-' + mod in conf.env['NS3_MODULES']:
                 _enabled_mods.append('ns3-' + mod)
-            elif mod in conf.env['NS3_CONTRIBUTED_MODULES'] and mod.startswith('ns3-'): 
+            elif mod in conf.env['NS3_CONTRIBUTED_MODULES'] and mod.startswith('ns3-'):
                 _enabled_contrib_mods.append(mod)
-            elif 'ns3-' + mod in conf.env['NS3_CONTRIBUTED_MODULES']: 
+            elif 'ns3-' + mod in conf.env['NS3_CONTRIBUTED_MODULES']:
                 _enabled_contrib_mods.append('ns3-' + mod)
         conf.env['NS3_ENABLED_MODULES'] = _enabled_mods
         conf.env['NS3_ENABLED_CONTRIBUTED_MODULES'] = _enabled_contrib_mods
-        
+
     else:
         # Use the enabled modules list from the ns3 configuration file.
         if modules_enabled[0] == 'all_modules':
@@ -539,14 +782,14 @@
             # Enable the modules from the list.
             _enabled_mods = []
             _enabled_contrib_mods = []
-            for mod in modules_enabled: 
-                if mod in conf.env['NS3_MODULES'] and mod.startswith('ns3-'): 
+            for mod in modules_enabled:
+                if mod in conf.env['NS3_MODULES'] and mod.startswith('ns3-'):
                     _enabled_mods.append(mod)
-                elif 'ns3-' + mod in conf.env['NS3_MODULES']: 
+                elif 'ns3-' + mod in conf.env['NS3_MODULES']:
                     _enabled_mods.append('ns3-' + mod)
-                elif mod in conf.env['NS3_CONTRIBUTED_MODULES'] and mod.startswith('ns3-'): 
+                elif mod in conf.env['NS3_CONTRIBUTED_MODULES'] and mod.startswith('ns3-'):
                     _enabled_contrib_mods.append(mod)
-                elif 'ns3-' + mod in conf.env['NS3_CONTRIBUTED_MODULES']: 
+                elif 'ns3-' + mod in conf.env['NS3_CONTRIBUTED_MODULES']:
                     _enabled_contrib_mods.append('ns3-' + mod)
             conf.env['NS3_ENABLED_MODULES'] = _enabled_mods
             conf.env['NS3_ENABLED_CONTRIBUTED_MODULES'] = _enabled_contrib_mods
@@ -588,11 +831,11 @@
 
     # Decide if tests will be built or not.
     if Options.options.enable_tests:
-        # Tests were explicitly enabled. 
+        # Tests were explicitly enabled.
         env['ENABLE_TESTS'] = True
         why_not_tests = "option --enable-tests selected"
     elif Options.options.disable_tests:
-        # Tests were explicitly disabled. 
+        # Tests were explicitly disabled.
         env['ENABLE_TESTS'] = False
         why_not_tests = "option --disable-tests selected"
     else:
@@ -609,11 +852,11 @@
 
     # Decide if examples will be built or not.
     if Options.options.enable_examples:
-        # Examples were explicitly enabled. 
+        # Examples were explicitly enabled.
         env['ENABLE_EXAMPLES'] = True
         why_not_examples = "option --enable-examples selected"
     elif Options.options.disable_examples:
-        # Examples were explicitly disabled. 
+        # Examples were explicitly disabled.
         env['ENABLE_EXAMPLES'] = False
         why_not_examples = "option --disable-examples selected"
     else:
@@ -626,7 +869,7 @@
         else:
             why_not_examples = "defaults to disabled"
 
-    conf.report_optional_feature("ENABLE_EXAMPLES", "Examples", env['ENABLE_EXAMPLES'], 
+    conf.report_optional_feature("ENABLE_EXAMPLES", "Examples", env['ENABLE_EXAMPLES'],
                                  why_not_examples)
     try:
         for dir in os.listdir('examples'):
@@ -703,7 +946,7 @@
             conf.env.append_value(confvar, value)
 
     print_config(env)
-    
+
 
 class SuidBuild_task(Task.Task):
     """task that makes a binary Suid
@@ -775,7 +1018,7 @@
     else:
         if program.env.DEST_BINFMT == 'elf':
             # All ELF platforms are impacted but only the gcc compiler has a flag to fix it.
-            if 'gcc' in (program.env.CXX_NAME, program.env.CC_NAME): 
+            if 'gcc' in (program.env.CXX_NAME, program.env.CC_NAME):
                 program.env.append_value ('SHLIB_MARKER', '-Wl,--no-as-needed')
 
     return program
@@ -878,7 +1121,7 @@
         if Options.options.check_profile:
             profile = get_build_profile()
             print("Build profile: %s" % profile)
-        
+
     if Options.options.check_profile or Options.options.check_config:
         raise SystemExit(0)
         return
@@ -909,11 +1152,18 @@
     bld.__class__.all_task_gen = property(_get_all_task_gen)
     bld.exclude_taskgen = types.MethodType(_exclude_taskgen, bld)
     bld.find_ns3_module = types.MethodType(_find_ns3_module, bld)
+    bld.missing_boost_libs = types.MethodType(bld_missing_boost_libs, bld)
 
     # Clean documentation build directories; other cleaning happens later
     if bld.cmd == 'clean':
         _cleandocs()
 
+    # Cache available boost lib names
+    bld.boost_libs = set()
+    if bld.env['LIB_BOOST']:
+        bld.boost_libs = get_boost_libs(bld.env['LIB_BOOST'])
+
+
     # process subfolders from here
     bld.recurse('src')
     bld.recurse('contrib')
@@ -939,10 +1189,10 @@
                     if not dep.startswith('ns3-'):
                         continue
                     if dep not in modules and dep not in contribModules:
-                        if dep in env['NS3_MODULES']: 
+                        if dep in env['NS3_MODULES']:
                             modules.append(dep)
                             changed = True
-                        elif dep in env['NS3_CONTRIBUTED_MODULES']: 
+                        elif dep in env['NS3_CONTRIBUTED_MODULES']:
                             contribModules.append(dep)
                             changed = True
                         else:
@@ -989,7 +1239,7 @@
                 # Add this program to the list if all of its
                 # dependencies will be built.
                 if program_built:
-                    object_name = "%s%s-%s%s" % (wutils.APPNAME, wutils.VERSION, 
+                    object_name = "%s%s-%s%s" % (wutils.APPNAME, wutils.VERSION,
                                                   obj.name, bld.env.BUILD_SUFFIX)
 
                     # Get the relative path to the program from the
@@ -1013,13 +1263,13 @@
             # disable the ns3header_taskgen
             if 'ns3header' in getattr(obj, "features", []):
                 if ("ns3-%s" % obj.module) not in modules and ("ns3-%s" % obj.module) not in contribModules:
-                    obj.mode = 'remove' # tell it to remove headers instead of installing 
+                    obj.mode = 'remove' # tell it to remove headers instead of installing
 
             # disable the ns3privateheader_taskgen
             if 'ns3privateheader' in getattr(obj, "features", []):
                 if ("ns3-%s" % obj.module) not in modules and ("ns3-%s" % obj.module) not in contribModules:
 
-                    obj.mode = 'remove' # tell it to remove headers instead of installing 
+                    obj.mode = 'remove' # tell it to remove headers instead of installing
 
             # disable pcfile taskgens for disabled modules
             if 'ns3pcfile' in getattr(obj, "features", []):
@@ -1084,7 +1334,7 @@
                 gen.post()
 
     if Options.options.run or Options.options.pyrun:
-        bld.env['PRINT_BUILT_MODULES_AT_END'] = False 
+        bld.env['PRINT_BUILT_MODULES_AT_END'] = False
 
     if Options.options.doxygen_no_build:
         _doxygen(bld, skip_pid=True)
@@ -1157,16 +1407,15 @@
 
     # Write the build status file.
     build_status_file = os.path.join(bld.out_dir, 'build-status.py')
-    out = open(build_status_file, 'w')
-    out.write('#! /usr/bin/env python3\n')
-    out.write('\n')
-    out.write('# Programs that are runnable.\n')
-    out.write('ns3_runnable_programs = ' + str(env['NS3_RUNNABLE_PROGRAMS']) + '\n')
-    out.write('\n')
-    out.write('# Scripts that are runnable.\n')
-    out.write('ns3_runnable_scripts = ' + str(env['NS3_RUNNABLE_SCRIPTS']) + '\n')
-    out.write('\n')
-    out.close()
+    with open(build_status_file, 'w') as out:
+        out.write('#! /usr/bin/env python3\n')
+        out.write('\n')
+        out.write('# Programs that are runnable.\n')
+        out.write('ns3_runnable_programs = ' + str(env['NS3_RUNNABLE_PROGRAMS']) + '\n')
+        out.write('\n')
+        out.write('# Scripts that are runnable.\n')
+        out.write('ns3_runnable_scripts = ' + str(env['NS3_RUNNABLE_SCRIPTS']) + '\n')
+        out.write('\n')
 
     if Options.options.lcov_report:
         lcov_report(bld)
@@ -1203,7 +1452,7 @@
         bld.options = Options.options # provided for convenience
         bld.cmd = "build"
         bld.execute()
-        
+
         wutils.bld = bld
         wutils.run_python_program("test.py -n -c core", bld.env)
 
@@ -1231,7 +1480,7 @@
 class Ns3ShellContext(Context.Context):
     """run a shell with an environment suitably modified to run locally built programs"""
     cmd = 'shell'
-    
+
     def execute(self):
         # first we execute the build
         bld = Context.create_context("build")
@@ -1242,7 +1491,7 @@
         # Set this so that the lists won't be printed when the user
         # exits the shell.
         bld.env['PRINT_BUILT_MODULES_AT_END'] = False
-        
+
         if sys.platform == 'win32':
             shell = os.environ.get("COMSPEC", "cmd.exe")
         else:
@@ -1261,7 +1510,7 @@
     proc_env = wutils.get_proc_env()
     try:
         program_obj = wutils.find_program('print-introspected-doxygen', env)
-    except ValueError: 
+    except ValueError:
         Logs.warn("print-introspected-doxygen does not exist")
         raise SystemExit(1)
         return
@@ -1277,16 +1526,14 @@
     Logs.info("Running print-introspected-doxygen")
 
     # Create a header file with the introspected information.
-    doxygen_out = open(os.path.join('doc', 'introspected-doxygen.h'), 'w')
-    if subprocess.Popen([prog], stdout=doxygen_out, env=proc_env).wait():
-        raise SystemExit(1)
-    doxygen_out.close()
+    with open(os.path.join('doc', 'introspected-doxygen.h'), 'w') as doxygen_out:
+        if subprocess.Popen([prog], stdout=doxygen_out, env=proc_env).wait():
+            raise SystemExit(1)
 
     # Create a text file with the introspected information.
-    text_out = open(os.path.join('doc', 'ns3-object.txt'), 'w')
-    if subprocess.Popen([prog, '--output-text'], stdout=text_out, env=proc_env).wait():
-        raise SystemExit(1)
-    text_out.close()
+    with open(os.path.join('doc', 'ns3-object.txt'), 'w') as text_out:
+        if subprocess.Popen([prog, '--output-text'], stdout=text_out, env=proc_env).wait():
+            raise SystemExit(1)
 
     # Gather the CommandLine doxy
     # test.py appears not to create or keep the output directory
@@ -1297,7 +1544,7 @@
     proc_env['NS_COMMANDLINE_INTROSPECTION'] = '..'
     subprocess.run(["./test.py", "--nowaf", "--constrain=example"],
                    env=proc_env, stdout=subprocess.DEVNULL)
-    
+
     doxygen_out = os.path.join('doc', 'introspected-command-line.h')
     try:
         os.remove(doxygen_out)
@@ -1313,13 +1560,12 @@
 */\n
 """
         out_file.write(lines)
-    out_file.close()
 
     with open(doxygen_out,'a') as outfile:
         for in_file in glob.glob('testpy-output/*.command-line'):
             with open(in_file,'r') as infile:
                 outfile.write(infile.read())
-                
+
 def _doxygen(bld, skip_pid=False):
     env = wutils.bld.env
     proc_env = wutils.get_proc_env()
@@ -1342,9 +1588,8 @@
     # Get the doxygen config
     doxyfile = os.path.join('doc', 'doxygen.conf')
     Logs.info("docset: reading " + doxyfile)
-    doxygen_config = open(doxyfile, 'r')
-    doxygen_config_contents = doxygen_config.read()
-    doxygen_config.close()
+    with open(doxyfile, 'r') as doxygen_config:
+        doxygen_config_contents = doxygen_config.read()
 
     # Create the output directory
     docset_path = os.path.join('doc', 'docset')
@@ -1354,19 +1599,18 @@
         os.mkdir(docset_path)
 
     doxyfile = os.path.join('doc', 'doxygen.docset.conf')
-    doxygen_config = open(doxyfile, 'w')
-    Logs.info("docset: writing doxygen conf " + doxyfile)
-    doxygen_config.write(doxygen_config_contents)
-    doxygen_config.write(
-        """
-        HAVE_DOT = NO
-        GENERATE_DOCSET = YES
-        DISABLE_INDEX = YES
-        SEARCHENGINE = NO
-        GENERATE_TREEVIEW = NO
-        OUTPUT_DIRECTORY=""" + docset_path + "\n"
-        )
-    doxygen_config.close()
+    with open(doxyfile, 'w') as doxygen_config:
+        Logs.info("docset: writing doxygen conf " + doxyfile)
+        doxygen_config.write(doxygen_config_contents)
+        doxygen_config.write(
+            """
+            HAVE_DOT = NO
+            GENERATE_DOCSET = YES
+            DISABLE_INDEX = YES
+            SEARCHENGINE = NO
+            GENERATE_TREEVIEW = NO
+            OUTPUT_DIRECTORY=""" + docset_path + "\n"
+            )
 
     # Run Doxygen manually, so as to avoid build
     Logs.info("docset: running doxygen")
@@ -1396,7 +1640,7 @@
     shutil.move(docset_out, os.path.join('doc', 'ns-3.docset'))
 
     print("Docset built successfully.")
-    
+
 
 def _getVersion():
     """update the ns3_version.js file, when building documentation"""
@@ -1419,7 +1663,7 @@
 
 class Ns3SphinxContext(Context.Context):
     """build the Sphinx documentation: manual, tutorial, models"""
-    
+
     cmd = 'sphinx'
 
     def sphinx_build(self, path):
